<template>
	<div>
		<div class="row">
			<div class="col-10">
				<BusquedaTitulos ref="busquedaTitulos" />
			</div>
			<div class="col-2">
				<button
					v-if="auxFormDataStore.usuarioActualiza?.esLegales()"
					type="button"
					class="btn btn-secondary mt-4 p-1 px-2"
					@click="goToFormularioTitulo()"
				>
					<i class="bi bi-plus-square mx-1 fonts-sm"></i> NUEVO
				</button>
			</div>
		</div>

		<ListadoTitulos @updateTitulo="goToFormularioTitulo" />
	</div>
</template>

<script lang="ts">
// Libraries
import { useRouter } from "vue-router";
import Swal from "sweetalert2/dist/sweetalert2.js";
import shared from "@/shared.js";

const { loading } = shared();

// Components
import BusquedaTitulos from "@/components/inicio/BusquedaTitulos.vue";
import ListadoTitulos from "@/components/inicio/ListadoTitulos.vue";

// Entities
import type { Titulo } from "@/entities/Titulo";

// Stores
import { useTitulosStore } from "@/stores/titulos";
import { useAuxFormDataStore } from "@/stores/auxFormData";

export default {
	components: {
		BusquedaTitulos,
		ListadoTitulos,
	},
	setup() {
		const titulosStore = useTitulosStore();
		const auxFormDataStore = useAuxFormDataStore();

		const router = useRouter();

		return {
			auxFormDataStore,
			titulosStore,
			router,
		};
	},
	async mounted() {
		loading.show();
		try {
			await Promise.all([
				this.titulosStore.updateListado({
					persona: undefined,
					estado: null,
				}),
				this.auxFormDataStore.getEstados(),
			]);

			loading.hide();
		} catch (error: any) {
			console.log(error);
			loading.hide();
			Swal.fire({
				icon: "error",
				text: "Ocurrio un error al cargar datos de la aplicación",
			});
		}
	},
	methods: {
		goToFormularioTitulo(titulo: Titulo | undefined = undefined) {
			if (typeof titulo !== "undefined") {
				this.router.push({
					name: "formulario",
					params: { id: titulo?.id_titulo_ejec },
				});
			} else {
				this.router.push({ name: "formulario" });
			}
		},
	},
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
